diff --git a/src/child.c b/src/child.c
index 62ca8612..d269fef0 100644
--- a/src/child.c
+++ b/src/child.c
@@ -942,7 +942,7 @@ setup_sync()
 /*
   Called from Alt+F2 (or session launcher via child_launch).
  */
-void
+static void
 do_child_fork(int argc, char *argv[], int moni, bool launch)
 {
   setup_sync();
@@ -1000,8 +1000,16 @@ do_child_fork(int argc, char *argv[], int moni, bool launch)
 
       chdir(set_dir);
       setenv("PWD", set_dir, true);  // avoid softlink resolution
-      if (!launch)
+      // prevent shell startup from setting current directory to $HOME
+      // unless cloned/Alt+F2 (!launch)
+      if (!launch) {
         setenv("CHERE_INVOKING", "mintty", true);
+        // if cloned and then launched from Windows shortcut (!shortcut) 
+        // (by sanitizing taskbar icon grouping, #784, mintty/wsltty#96) 
+        // indicate to set proper directory
+        if (shortcut)
+          setenv("MINTTY_PWD", set_dir, true);
+      }
 
       if (support_wsl)
         delete(set_dir);
diff --git a/src/winmain.c b/src/winmain.c
index d2e0b3e1..3df93b17 100644
--- a/src/winmain.c
+++ b/src/winmain.c
@@ -3621,6 +3621,13 @@ main(int argc, char *argv[])
     icon_is_from_shortcut = true;
     unsetenv("MINTTY_ICON");
   }
+  if (getenv("MINTTY_PWD")) {
+    // if cloned and then launched from Windows shortcut 
+    // (by sanitizing taskbar icon grouping, #784, mintty/wsltty#96) 
+    // set proper directory
+    chdir(getenv("MINTTY_PWD"));
+    unsetenv("MINTTY_PWD");
+  }
 
   bool wdpresent = true;
   if (invoked_from_shortcut) {
